/***************************************************************************
 *  CISILIA PROJECT: callbacks.c
 *  
 *  Tue Jan  7 22:48:14 2003
 *  Copyright  2002-2003  Cisilia Team <cisilia@cisiar.org>
 *
 ****************************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <glob.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include "cisilia-data.h"

#define CLIST_T_ACT_RAFAGA	200	/* milisegundos */
#define CONEXION_MAX_INTENTOS 	10
#define CONEXION_T_INTENTOS 	500	/* milisegundos */
//#define V_PROM_ALFA       .01
#define CLIST1_CANT_COL		5	/* Cantidad de columnas en clist1 */
#define TIEMPO_ACTUALIZACION	100	/* milisegundos */

int sock;
GtkWidget *window2;
GtkWidget *notebook1;
GtkWidget *clist1;
GtkButton *button_ejecutar;
GtkWidget *barrita1;
GtkWidget *barrita2;
GtkWidget *label_tiempo;
GtkWidget *label_vprom;
GtkWidget *label_vinst;
GtkWidget *label_trestante;
GTimer *timer;
int subpid;
int puerto_backend;
gint conectado = FALSE;
gint cuenta_regresiva;
gint tag_input;
//gint tag_timeout_con;
gint tag_timeout_act;
gint bloqueoActClist = 0;
gint clist1_orden_columna[CLIST1_CANT_COL] = { GTK_SORT_DESCENDING };
gint16 detenido = FALSE;
gdouble t_previo_stop = 0;


int crearSocketEscuchaUDP(int puerto)
{
	int sock;
	struct sockaddr_in server;
	int ok = 1;

	sock = socket(PF_INET, SOCK_DGRAM, 0);
	if (sock < 0)
		perror("ERROR en socket()");

	server.sin_family = AF_INET;
	server.sin_addr.s_addr = htonl(INADDR_ANY);
	server.sin_port = htons(puerto);

	setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &ok, sizeof(ok));

	if (bind(sock, (struct sockaddr *) &server, sizeof server) < 0)
		perror("ERROR en bind()");

	return (sock);
}

/*
int conectarPadre(char *ip, int puerto, int puerto_local)
{
    int s;
    struct sockaddr_in server;
    struct hostent *hp;

    s = socket(PF_INET, SOCK_DGRAM, 0);
    if (s < 0) {
	perror("ERROR en socket()");
	return (-1);
    }

    server.sin_family = AF_INET;
    hp = gethostbyname(ip);
    if (hp == NULL) {
	perror("ERROR en gethostbyname()");
	return (-1);
    }
    memcpy((char *) &server.sin_addr, (char *) hp->h_addr, hp->h_length);
    server.sin_port = htons(puerto);

    sendto(s, &puerto_local, sizeof(puerto_local), 0, (struct sockaddr *) &server,
	   sizeof(server));
    close(s);

    return 0;
}
*/
void escuchar_backend(gpointer data, gint source, GdkInputCondition cond)
{
	gint rx;
	msgPadre buffer;
	gchar *datosFila[5];
	gint fila;
	double s;
	unsigned long m, h;
	estadisticas est;

	rx = recv(source, &buffer, sizeof(buffer), 0);

	if ((rx == sizeof(estadisticas) || rx == sizeof(datoCrack))) {
		if (conectado == FALSE) {
			g_message(_("Connection established."));
			fprintf(stderr, "\a");
			signal(SIGCHLD, SIG_IGN);
			conectado = TRUE;
		}
	}

	if (rx == 0) {
		destruir_window2(0, NULL);
		return;
	}

	if (rx == sizeof(estadisticas)) {
		if (buffer.data.pid == subpid) {	/* VALIDAR EL MENSAJE */
//printf("rx ");
//fflush(stdout);
			est = buffer.data;
			actualizar_estadisticas(&est);
		} else
			g_message(_("Invalid message from (PID:%d)."),
					  buffer.data.pid);
	}

	if (rx == sizeof(datoCrack)) {
		s = (buffer.crack.t.tv_sec - buffer.crack.ti.tv_sec) +
			(buffer.crack.t.tv_usec - buffer.crack.ti.tv_usec) * .000001;
		m = s / 60;
		h = m / 60;
		datosFila[0] = g_strdup_printf("%05llu", buffer.crack.cracks);
		datosFila[1] =
			g_strdup_printf("%02lu:%02lu:%06.3f", h, m - h * 60,
							s - m * 60);
		datosFila[2] = buffer.crack.nombre;
		datosFila[3] = buffer.crack.LMpasswd;
		datosFila[4] = buffer.crack.NTpasswd;
		fila = gtk_clist_append(GTK_CLIST(clist1), datosFila);
		g_free(datosFila[0]);
		g_free(datosFila[1]);
		gtk_clist_unselect_all(GTK_CLIST(clist1));
		gtk_clist_select_row(GTK_CLIST(clist1), fila, 0);
		if (bloqueoActClist == 0) {
			bloqueoActClist = 1;
			gtk_clist_freeze(GTK_CLIST(clist1));
			gtk_timeout_add(CLIST_T_ACT_RAFAGA, actualizar_clist,
							(gpointer) clist1);
		}
		gtk_clist_moveto(GTK_CLIST(clist1), fila, 0, 0.5, 0.0);
	}
}


void mostrar_fileselection(GtkButton * button, gpointer user_data)
{
	GtkWidget *fileselection1;
	gchar *ruta;
	fileselection1 = lookup_widget(GTK_WIDGET(button), "fileselection1");
	gtk_object_set_data(GTK_OBJECT(fileselection1), "entry",
						(gpointer) button);
	ruta = gtk_entry_get_text(GTK_ENTRY(button));
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(fileselection1),
									ruta);
	gtk_widget_show(fileselection1);
}



void on_ok_button1_clicked(GtkButton * button, gpointer user_data)
{
	gchar *file;
	GtkWidget *fileselection1;
	GtkWidget *entry;

	fileselection1 = lookup_widget(GTK_WIDGET(button), "fileselection1");
	file =
		gtk_file_selection_get_filename(GTK_FILE_SELECTION
										(fileselection1));

	entry = lookup_widget(GTK_WIDGET(button), "entry");
	gtk_entry_set_text(GTK_ENTRY(entry), file);
}


void ejecutar_cisilia(GtkButton * button, gpointer user_data)
{
//    GString *arg = g_string_new ("\0");
	gchar **argv = NULL;
	gchar *texto_frontend = NULL;
	gint argv_i = 0;
	gint col;
	gint i;

	button_ejecutar = button;

//printf("i=%d\n",argv_i);
//printf("argv[%d]=%s\n",argv_i,argv[argv_i-1]);

	if (procesar_entry(button, &argv, &argv_i, "entry_exe", "*") == 0) {
		g_message(_("Executable file missing."));
		g_free(argv);
		return;
	}
	procesar_entry(button, &argv, &argv_i, "entry_alf", "-a");
	procesar_entry(button, &argv, &argv_i, "entry_dic", "-d");
	procesar_entry(button, &argv, &argv_i, "entry_log", "-l");
	puerto_backend =
		procesar_spin(button, &argv, &argv_i, "spin_puerto", "-p");
	procesar_spin(button, &argv, &argv_i, "spin_procs", "-n");
	procesar_check(button, &argv, &argv_i, "check_verbose", "-V");
	texto_frontend = g_strconcat("--frontend=", DIR_FRONTEND, NULL);
	argv = argv_agregar_indice(argv, &argv_i, (gpointer) texto_frontend);
	if (procesar_entry(button, &argv, &argv_i, "entry_sam", "*") == 0) {
		g_message(_("Password file missing."));
		g_free(texto_frontend);
		g_free(argv);
		return;
	}
	argv = argv_agregar_indice(argv, &argv_i, NULL);

	for (i = 0; argv[i] != NULL; i++)
		fprintf(stderr, "%s ", argv[i]);
	fprintf(stderr, "\n");
	fflush(stderr);

	gtk_widget_set_sensitive(GTK_WIDGET(button), FALSE);
	window2 = create_window2();
	barrita1 =
		lookup_widget(GTK_WIDGET(window2), "progressbar_descifradas");
	barrita2 = lookup_widget(GTK_WIDGET(window2), "progressbar_generadas");
	label_tiempo = lookup_widget(GTK_WIDGET(window2), "label_tiempo");
	label_vprom = lookup_widget(GTK_WIDGET(window2), "label_vprom");
	label_vinst = lookup_widget(GTK_WIDGET(window2), "label_vinst");
	label_trestante =
		lookup_widget(GTK_WIDGET(window2), "label_trestante");
	timer = g_timer_new();
//    cuenta_regresiva = CONEXION_MAX_INTENTOS;
//    tag_timeout_con = gtk_timeout_add (CONEXION_T_INTENTOS,intentar_conexion,(gpointer)button);
	gtk_widget_show(window2);
	notebook1 = lookup_widget(GTK_WIDGET(button), "notebook1");
	gtk_notebook_set_page(GTK_NOTEBOOK(notebook1), 1);
	clist1 = lookup_widget(GTK_WIDGET(button), "clist1");
	for (col = 0; col < CLIST1_CANT_COL; col++)
		gtk_clist_set_column_resizeable(GTK_CLIST(clist1), col, TRUE);

/* HAY QUE ACTUALIZAR ANTES DE CONECTARSE PARA INICIAR LOS DATOS ESTATICOS DE LA FUNCION */
	actualizar_estadisticas(NULL);
	tag_timeout_act =
		gtk_timeout_add(TIEMPO_ACTUALIZACION, actualizar_estadisticas,
						NULL);

/* ABRIR SOCKET DE ESCUCHA */
	sock = crearSocketEscuchaUDP(PUERTO_FRONTEND);
	tag_input =
		gdk_input_add(sock, GDK_INPUT_READ, escuchar_backend,
					  (gpointer) window2);

	signal(SIGCHLD, capturar_muerte_backend);
	detenido = FALSE;
	t_previo_stop = 0;

	switch (subpid = fork()) {
	case -1:
		perror("ERROR en fork");
		gtk_widget_set_sensitive(GTK_WIDGET(button), TRUE);
		destruir_window2(0, NULL);
//      g_strfreev(argv);
		return;
		break;
	case 0:
		execvp(argv[0], argv);
		perror("ERROR en execv()");
		_exit(0);
//    default:
//  g_strfreev (argv);
//  for (i=0; argv[i]!=NULL; i++) {
//      fprintf (stderr,"argv[%d]=%s... ",i,argv[i]);
//      g_free (argv[i]);
//      fprintf (stderr,"liberado\n");
//  }
	}
}


gchar **argv_agregar_indice(gchar ** argv, gint * pos, gchar * s)
{
	argv =
		(gchar **) g_realloc((gpointer) argv,
							 ((*pos) + 1) * sizeof(gchar *));
	argv[*pos] = s;
	(*pos)++;
	return argv;
}

/*
gint intentar_conexion (gpointer data)
{    
    if (conectarPadre ("127.0.0.1", puerto_backend, PUERTO_FRONTEND) !=0 ) {
        g_message (_("Cannot connect with the back-end."));
	gtk_notebook_set_page (GTK_NOTEBOOK(notebook1), 0);
	destruir_window2 (0,NULL);
	return FALSE;
    }

    if(cuenta_regresiva-- == 0) {
    	if (conectado == FALSE) {
	    g_message (_("Cannot connect with the back-end."));
	    gtk_notebook_set_page (GTK_NOTEBOOK(notebook1), 0);
	    destruir_window2 (0,NULL);
	}	    
        return FALSE;
    }
    else
	return TRUE;
}
*/

void capturar_muerte_backend(int senial)
{
	if (waitpid(subpid, NULL, WNOHANG) != 0) {
		g_warning(_("Backend died."));
		if (conectado == FALSE)
			gtk_notebook_set_page(GTK_NOTEBOOK(notebook1), 0);
		destruir_window2(0, NULL);
	}
	return;
}


gint es_cadena_valida(const gchar * s)
{
	int i;
	for (i = 0; i < strlen(s); i++)
		if (isgraph(s[i]))
			return 1;
	return 0;
}


gchar *leer_entry(GtkButton * button, const gchar * nombre_widget)
{
	gchar *valor;
	GtkWidget *widget;
	widget = lookup_widget(GTK_WIDGET(button), nombre_widget);
	valor = gtk_entry_get_text(GTK_ENTRY(widget));
	return valor;
}


gint procesar_entry(GtkButton * button, gchar *** argv, gint * i,
					const gchar * nombre_widget, const gchar * parametro)
{
	gchar *valor = leer_entry(button, nombre_widget);
	if (es_cadena_valida(valor) == 0)
		return 0;
	if (((*i) > 0) && (strchr(parametro, '*') == NULL))
		*argv = argv_agregar_indice(*argv, i, (gpointer) parametro);
	*argv = argv_agregar_indice(*argv, i, (gpointer) valor);
	return 1;
}


gint procesar_spin(GtkButton * button, gchar *** argv, gint * i,
				   const gchar * nombre_widget, const gchar * parametro)
{
	gint valor;
	GtkWidget *widget;
	widget = lookup_widget(GTK_WIDGET(button), nombre_widget);
	valor = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(widget));
	if (GTK_WIDGET_SENSITIVE(widget) == TRUE) {
		*argv = argv_agregar_indice(*argv, i, (gpointer) parametro);
		*argv =
			argv_agregar_indice(*argv, i,
								(gpointer) g_strdup_printf("%d", valor));
	}
	return valor;
}


gint procesar_check(GtkButton * button, gchar *** argv, gint * i,
					const gchar * nombre_widget, const gchar * parametro)
{
	GtkWidget *widget;
	widget = lookup_widget(GTK_WIDGET(button), nombre_widget);
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget))) {
		*argv = argv_agregar_indice(*argv, i, (gpointer) parametro);
		return 1;
	} else
		return 0;
}


void
autocompletar(GtkEditable * editable, gchar * new_text,
			  gint new_text_length, gint * position, gpointer user_data)
{
	int i;
	GList *g_lista = NULL;
	GCompletion *completar = NULL;
	gchar *texto_actual = NULL;
	gchar *texto_glob = NULL;
	gchar *completado = NULL;
	glob_t exp;
	gint pos;

	completar = g_completion_new(NULL);
//    texto_actual = gtk_entry_get_text(GTK_ENTRY(editable));
	texto_actual = gtk_editable_get_chars(editable, 0, *position);
	texto_glob = g_strconcat(texto_actual, "*", NULL);
	glob(texto_glob, GLOB_MARK | GLOB_TILDE, NULL, &exp);
	g_free(texto_glob);
	for (i = 0; i < exp.gl_pathc; i++) {
//  fprintf(stderr,"exp: %s\n",exp.gl_pathv[i]);
		g_lista = g_list_append(g_lista, exp.gl_pathv[i]);
	}
	if (g_lista != NULL) {
		g_completion_add_items(completar, g_lista);

		if (g_completion_complete(completar, texto_actual, &completado) !=
			NULL) {
//      fprintf(stderr," %s ==> %s\n",texto_actual,completado);
//      fprintf(stderr,"pos = %d => ",*position);
			gtk_editable_select_region(editable, 0, *position);
			gtk_editable_delete_selection(editable);
			gtk_signal_handler_block_by_func(GTK_OBJECT(editable),
											 autocompletar, NULL);
			pos = *position;
			*position = 0;
			gtk_editable_insert_text(editable, completado,
									 strlen(completado), position);
			gtk_signal_handler_unblock_by_func(GTK_OBJECT(editable),
											   autocompletar, NULL);
			gtk_editable_select_region(editable, pos, *position);
			gtk_editable_claim_selection(editable, TRUE, GDK_CURRENT_TIME);
//      fprintf(stderr,"pos = %d\n",*position);
		}
	}
	g_free(texto_actual);
	globfree(&exp);
	g_list_free(g_lista);
	g_completion_free(completar);
//    fprintf(stderr,"pos = %d\n\n",*position);
}


void
cambiar_sensibilidad(GtkToggleButton * togglebutton, gpointer user_data)
{
	if (GTK_WIDGET_SENSITIVE(GTK_WIDGET(togglebutton)) == TRUE)
		gtk_widget_set_sensitive(GTK_WIDGET(togglebutton), FALSE);
	else
		gtk_widget_set_sensitive(GTK_WIDGET(togglebutton), TRUE);
}


void
on_clist1_click_column(GtkCList * clist, gint column, gpointer user_data)
{
	gint i;
	gtk_clist_set_sort_column(clist, column);
	gtk_clist_set_compare_func(clist, NULL);

	if (clist1_orden_columna[column] != GTK_SORT_ASCENDING)
		clist1_orden_columna[column] = GTK_SORT_ASCENDING;
	else
		clist1_orden_columna[column] = GTK_SORT_DESCENDING;

	for (i = 0; i < CLIST1_CANT_COL; i++)
		if (i != column)
			clist1_orden_columna[i] = GTK_SORT_DESCENDING;

	gtk_clist_set_sort_type(clist, clist1_orden_columna[column]);
	gtk_clist_sort(clist);
	gtk_clist_set_auto_sort(clist, TRUE);
}


void on_button_borrar_clicked(GtkButton * button, gpointer user_data)
{
	gtk_clist_clear(GTK_CLIST(button));
}


gboolean actualizar_clist(gpointer data)
{
	if (bloqueoActClist == 0)
		return FALSE;
	gtk_clist_thaw(GTK_CLIST(data));
	bloqueoActClist = 0;
	return TRUE;
}


gint actualizar_estadisticas(gpointer data)
{
	gchar *texto_tiempo;
	gchar *texto_vprom;
	gchar *texto_vinst;
	gchar *texto_trestante;
	gdouble s;
	gdouble sr;
	gulong m, h, mr, hr;
	gdouble vinst, vprom;
	static unsigned long long palabrasPrev = 0;
	static gdouble vpromPrevia = 0;
	static gdouble sPrevios = 0;
	static estadisticas est;

	if (data != NULL) {
		est = *((estadisticas *) data);
	} else {
		if (conectado == FALSE) {
			palabrasPrev = 0;
			sPrevios = 0;
			vpromPrevia = 0;
			est.cracks = 0;
			est.lineas = 0;
			est.palabras = 0;
			est.total_palabras = 0;
		}
//fprintf(stderr,"cracks:  %llu  lineas:%d\n", est.cracks, est.lineas);
//fprintf(stderr,"palabras:%llu  total: %llu\n", est.palabras, est.total_palabras); 

		if (est.lineas > 0)
			gtk_progress_configure(GTK_PROGRESS(barrita1), est.cracks, 0,
								   est.lineas);
		if (est.total_palabras > 0)
			gtk_progress_configure(GTK_PROGRESS(barrita2), est.palabras, 0,
								   est.total_palabras);

		s = g_timer_elapsed(timer, NULL) + t_previo_stop;
		m = s / 60;
		h = m / 60;

		if (s == sPrevios)
			vinst = 0;
		else
			vinst = (est.palabras - palabrasPrev) / (s - sPrevios);

//  if (vpromPrevia < 0.1)
//      vprom = vinst;
//  else
//      vprom = vinst * V_PROM_ALFA + vpromPrevia * (1.0 - V_PROM_ALFA);
		vprom = est.palabras / s;
		texto_vinst = g_strdup_printf("%.1f", vinst);
		texto_vprom = g_strdup_printf("%.1f", vprom);
//      fprintf(stderr,"vinst = %.1f\n",vinst);
		sr = (est.total_palabras - est.palabras) / (vprom);
		mr = sr / 60;
		hr = mr / 60;

		texto_tiempo =
			g_strdup_printf("%luh %02lum %02.1fs", h, m - h * 60,
							s - m * 60);
		texto_trestante =
			g_strdup_printf("%luh %02lum %02.0fs", hr, mr - hr * 60,
							sr - mr * 60);
		gtk_label_set_text(GTK_LABEL(label_tiempo), texto_tiempo);
		gtk_label_set_text(GTK_LABEL(label_vprom), texto_vprom);
		gtk_label_set_text(GTK_LABEL(label_vinst), texto_vinst);
		gtk_label_set_text(GTK_LABEL(label_trestante), texto_trestante);

		g_free(texto_tiempo);
		g_free(texto_vprom);
		g_free(texto_vinst);
		g_free(texto_trestante);

		sPrevios = s;
		palabrasPrev = est.palabras;
		vpromPrevia = vprom;
	}
	return TRUE;
}


void on_acerca_de1_activate(GtkMenuItem * menuitem, gpointer user_data)
{
	GtkWidget *about1 = create_about1();
	gtk_widget_show(GTK_WIDGET(about1));
}


void on_button_salir_clicked(GtkButton * button, gpointer user_data)
{
	GtkWidget *pregunta;
	if (conectado)
		pregunta =
			gnome_question_dialog_modal(_
										("Do you really want to close this window?\nThe back-end processes will be killed, too."),
										destruir_window1, NULL);
	else
		destruir_window1(0, NULL);
}


void
on_button_cerrar_estadisticas_clicked(GtkButton * button,
									  gpointer user_data)
{
	GtkWidget *pregunta;
	pregunta =
		gnome_question_dialog_modal(_
									("Do you really want to close this window?\nThe back-end processes will be killed, too."),
									destruir_window2, NULL);
}


void destruir_window1(gint reply, gpointer user_data)
{
	if (reply == 0) {
		if (conectado)
			matar_backend(NULL, NULL);

		gtk_main_quit();
	}
}


void destruir_window2(gint reply, gpointer user_data)
{
	if (reply == 0) {
		signal(SIGCHLD, SIG_IGN);
		matar_backend(NULL, NULL);
		gdk_input_remove(tag_input);
		close(sock);
		gtk_timeout_remove(tag_timeout_act);
//  gtk_timeout_remove (tag_timeout_con);
		g_timer_destroy(timer);
		gtk_widget_destroy(window2);
		conectado = FALSE;
		gtk_widget_set_sensitive(GTK_WIDGET(button_ejecutar), TRUE);
	}
}


gboolean
on_window1_delete_event(GtkWidget * widget,
						GdkEvent * event, gpointer user_data)
{
	GtkWidget *pregunta;
	if (conectado)
		pregunta =
			gnome_question_dialog_modal(_
										("Do you really want to close this window?\nThe back-end processes will be killed, too."),
										destruir_window1, NULL);
	else
		destruir_window1(0, NULL);
/* DEBE DEVOLVER TRUE PARA DETENER EL HANDLER PREDETERMINADO */
	return TRUE;
}


gboolean
on_window2_delete_event(GtkWidget * widget,
						GdkEvent * event, gpointer user_data)
{
	GtkWidget *pregunta;
	pregunta =
		gnome_question_dialog_modal(_
									("Do you really want to close this window?\nThe back-end processes will be killed, too."),
									destruir_window2, NULL);
/* DEBE DEVOLVER TRUE PARA DETENER EL HANDLER PREDETERMINADO */
	return TRUE;
}


void matar_backend(GtkWidget * widget, gpointer user_data)
{
	kill(-subpid, SIGCONT);
	signal(SIGCHLD, SIG_IGN);
	if (kill(subpid, SIGINT) == 0)
		g_message(_("Back-end killed."));
	else
		perror("ERROR eliminando back-end");
}


void on_button_stop_clicked(GtkButton * button, gpointer user_data)
{
	GtkWidget *label_stop;
	static gdouble t_previo_stop_aux;

	label_stop = lookup_widget(GTK_WIDGET(button), "label_stop");

	if (detenido == FALSE) {
		kill(-subpid, SIGTSTP);
		detenido = TRUE;
		t_previo_stop_aux = g_timer_elapsed(timer, NULL);
		g_timer_stop(timer);
		gtk_window_set_title(GTK_WINDOW(window2), _("Cisilia: STOPPED"));
		gtk_label_set_text(GTK_LABEL(label_stop), _("Resume"));
	} else {
		kill(-subpid, SIGCONT);
		detenido = FALSE;
		t_previo_stop += t_previo_stop_aux;
		g_timer_start(timer);
		gtk_window_set_title(GTK_WINDOW(window2), _("Cisilia: RUNNING"));
		gtk_label_set_text(GTK_LABEL(label_stop), _("Stop"));
	}

}
